diff --git a/src/plots/cartesian/axes.js b/src/plots/cartesian/axes.js
index d8e99dd2eb7..a48b9dcd16f 100644
--- a/src/plots/cartesian/axes.js
+++ b/src/plots/cartesian/axes.js
@@ -946,7 +946,7 @@ axes.calcTicks = function calcTicks(ax, opts) {
 
     var lastVisibleHead;
     var hideLabel = function(tick) {
-        tick.text = ' '; // don't use an empty string here which can confuse automargin (issue 5132)
+        tick.text = '';
         ax._prevDateHead = lastVisibleHead;
     };
 
@@ -3008,7 +3008,7 @@ axes.drawLabels = function(gd, ax, opts) {
     var axLetter = axId.charAt(0);
     var cls = opts.cls || axId + 'tick';
 
-    var vals = opts.vals;
+    var vals = opts.vals.filter(function(e) { return e.text; });
 
     var labelFns = opts.labelFns;
     var tickAngle = opts.secondary ? 0 : ax.tickangle;
diff --git a/test/jasmine/tests/axes_test.js b/test/jasmine/tests/axes_test.js
index 0c336d948fa..6793b526397 100644
--- a/test/jasmine/tests/axes_test.js
+++ b/test/jasmine/tests/axes_test.js
@@ -5591,7 +5591,7 @@ describe('Test axes', function() {
 
             for(var i = 0; i < labels.length; i++) {
                 expect(labels[i]).withContext(msg).toBe(expLabels[i]);
-                if(labels[i] !== ' ') {
+                if(labels[i] !== '') {
                     expect(positions[i]).withContext(msg).toBe(expPositions[i]);
                 }
             }
@@ -5623,8 +5623,8 @@ describe('Test axes', function() {
                         '2025-07-02 12:00',
                         '2026-07-02 12:00'
                     ], [
-                        [' ', '2020', '2021', '2022', '2023', '2024', '2025', ' '],
-                        [' ', '20', '21', '22', '23', '24', '25', ' ']
+                        ['', '2020', '2021', '2022', '2023', '2024', '2025', ''],
+                        ['', '20', '21', '22', '23', '24', '25', '']
                     ][i]);
                 })
                 .then(done, done.fail);
@@ -5657,7 +5657,7 @@ describe('Test axes', function() {
                     '2021-08-16',
                     '2021-11-16',
                     '2022-02-16'
-                ], [' ', '2020-Q1', '2020-Q2', '2020-Q3', '2020-Q4', '2021-Q1', '2021-Q2', '2021-Q3', '2021-Q4', ' ']);
+                ], ['', '2020-Q1', '2020-Q2', '2020-Q3', '2020-Q4', '2021-Q1', '2021-Q2', '2021-Q3', '2021-Q4', '']);
             })
             .then(done, done.fail);
         });
@@ -5685,7 +5685,7 @@ describe('Test axes', function() {
                     '2021-02-15 15:45',
                     '2021-08-15 15:45',
                     '2022-02-15 15:45'
-                ], [' ', '2020-Q1', '2020-Q3', '2021-Q1', '2021-Q3', ' ']);
+                ], ['', '2020-Q1', '2020-Q3', '2021-Q1', '2021-Q3', '']);
             })
             .then(done, done.fail);
         });
@@ -5716,9 +5716,9 @@ describe('Test axes', function() {
                         '2020-06-16',
                         '2020-07-16'
                     ], [
-                        [' ', 'Q1-January', 'Q1-February', 'Q1-March', 'Q2-April', 'Q2-May', 'Q2-June', ' '],
-                        [' ', 'Q1-Jan', 'Q1-Feb', 'Q1-Mar', 'Q2-Apr', 'Q2-May', 'Q2-Jun', ' '],
-                        [' ', 'Q1-01', 'Q1-02', 'Q1-03', 'Q2-04', 'Q2-05', 'Q2-06', ' ']
+                        ['', 'Q1-January', 'Q1-February', 'Q1-March', 'Q2-April', 'Q2-May', 'Q2-June', ''],
+                        ['', 'Q1-Jan', 'Q1-Feb', 'Q1-Mar', 'Q2-Apr', 'Q2-May', 'Q2-Jun', ''],
+                        ['', 'Q1-01', 'Q1-02', 'Q1-03', 'Q2-04', 'Q2-05', 'Q2-06', '']
                     ][i]);
                 })
                 .then(done, done.fail);
@@ -5882,14 +5882,14 @@ describe('Test axes', function() {
                         '2020-01-07 12:00',
                         '2020-01-08 12:00'
                     ], [
-                        [' ', 'Jan-Wednesday', 'Jan-Thursday', 'Jan-Friday', 'Jan-Saturday', 'Jan-Sunday', 'Jan-Monday', 'Jan-Tuesday', ' '],
-                        [' ', 'Jan-Wed', 'Jan-Thu', 'Jan-Fri', 'Jan-Sat', 'Jan-Sun', 'Jan-Mon', 'Jan-Tue', ' '],
-                        [' ', 'Jan-01', 'Jan-02', 'Jan-03', 'Jan-04', 'Jan-05', 'Jan-06', 'Jan-07', ' '],
-                        [' ', 'Jan- 1', 'Jan- 2', 'Jan- 3', 'Jan- 4', 'Jan- 5', 'Jan- 6', 'Jan- 7', ' '],
-                        [' ', 'Jan-001', 'Jan-002', 'Jan-003', 'Jan-004', 'Jan-005', 'Jan-006', 'Jan-007', ' '],
-                        [' ', 'Jan-3', 'Jan-4', 'Jan-5', 'Jan-6', 'Jan-7', 'Jan-1', 'Jan-2', ' '],
-                        [' ', 'Jan-3', 'Jan-4', 'Jan-5', 'Jan-6', 'Jan-0', 'Jan-1', 'Jan-2', ' '],
-                        [' ', 'Jan-01/01/2020', 'Jan-01/02/2020', 'Jan-01/03/2020', 'Jan-01/04/2020', 'Jan-01/05/2020', 'Jan-01/06/2020', 'Jan-01/07/2020', ' ']
+                        ['', 'Jan-Wednesday', 'Jan-Thursday', 'Jan-Friday', 'Jan-Saturday', 'Jan-Sunday', 'Jan-Monday', 'Jan-Tuesday', ''],
+                        ['', 'Jan-Wed', 'Jan-Thu', 'Jan-Fri', 'Jan-Sat', 'Jan-Sun', 'Jan-Mon', 'Jan-Tue', ''],
+                        ['', 'Jan-01', 'Jan-02', 'Jan-03', 'Jan-04', 'Jan-05', 'Jan-06', 'Jan-07', ''],
+                        ['', 'Jan- 1', 'Jan- 2', 'Jan- 3', 'Jan- 4', 'Jan- 5', 'Jan- 6', 'Jan- 7', ''],
+                        ['', 'Jan-001', 'Jan-002', 'Jan-003', 'Jan-004', 'Jan-005', 'Jan-006', 'Jan-007', ''],
+                        ['', 'Jan-3', 'Jan-4', 'Jan-5', 'Jan-6', 'Jan-7', 'Jan-1', 'Jan-2', ''],
+                        ['', 'Jan-3', 'Jan-4', 'Jan-5', 'Jan-6', 'Jan-0', 'Jan-1', 'Jan-2', ''],
+                        ['', 'Jan-01/01/2020', 'Jan-01/02/2020', 'Jan-01/03/2020', 'Jan-01/04/2020', 'Jan-01/05/2020', 'Jan-01/06/2020', 'Jan-01/07/2020', '']
                     ][i]);
                 })
                 .then(done, done.fail);
@@ -5924,9 +5924,9 @@ describe('Test axes', function() {
                         '2020-01-01 21:00',
                         '2020-01-02'
                     ], [
-                        [' ', 'Wed-1577836800000', 'Wed-1577847600000', 'Wed-1577858400000', 'Wed-1577869200000', 'Wed-1577880000000', 'Wed-1577890800000', 'Wed-1577901600000', 'Wed-1577912400000', 'Thu-1577923200000'],
-                        [' ', 'Wed-1577836800', 'Wed-1577847600', 'Wed-1577858400', 'Wed-1577869200', 'Wed-1577880000', 'Wed-1577890800', 'Wed-1577901600', 'Wed-1577912400', 'Thu-1577923200'],
-                        [' ', 'Wed-00:00:00', 'Wed-03:00:00', 'Wed-06:00:00', 'Wed-09:00:00', 'Wed-12:00:00', 'Wed-15:00:00', 'Wed-18:00:00', 'Wed-21:00:00', 'Thu-00:00:00']
+                        ['', 'Wed-1577836800000', 'Wed-1577847600000', 'Wed-1577858400000', 'Wed-1577869200000', 'Wed-1577880000000', 'Wed-1577890800000', 'Wed-1577901600000', 'Wed-1577912400000', 'Thu-1577923200000'],
+                        ['', 'Wed-1577836800', 'Wed-1577847600', 'Wed-1577858400', 'Wed-1577869200', 'Wed-1577880000', 'Wed-1577890800', 'Wed-1577901600', 'Wed-1577912400', 'Thu-1577923200'],
+                        ['', 'Wed-00:00:00', 'Wed-03:00:00', 'Wed-06:00:00', 'Wed-09:00:00', 'Wed-12:00:00', 'Wed-15:00:00', 'Wed-18:00:00', 'Wed-21:00:00', 'Thu-00:00:00']
                     ][i]);
                 })
                 .then(done, done.fail);
@@ -5937,37 +5937,37 @@ describe('Test axes', function() {
             {
                 formatter: '%H',
                 positions: ['2019-12-31 21:30', '2020-01-01 00:30', '2020-01-01 03:30', '2020-01-01 06:30', '2020-01-01 09:30', '2020-01-01 12:30', '2020-01-01 15:30', '2020-01-01 18:30', '2020-01-01 21:30', '2020-01-02 00:30'],
-                labels: [' ', 'Wed-00', 'Wed-03', 'Wed-06', 'Wed-09', 'Wed-12', 'Wed-15', 'Wed-18', 'Wed-21', 'Thu-00']
+                labels: ['', 'Wed-00', 'Wed-03', 'Wed-06', 'Wed-09', 'Wed-12', 'Wed-15', 'Wed-18', 'Wed-21', 'Thu-00']
             },
             {
                 formatter: '%I',
                 positions: ['2019-12-31 21:30', '2020-01-01 00:30', '2020-01-01 03:30', '2020-01-01 06:30', '2020-01-01 09:30', '2020-01-01 12:30', '2020-01-01 15:30', '2020-01-01 18:30', '2020-01-01 21:30', '2020-01-02 00:30'],
-                labels: [' ', 'Wed-12', 'Wed-03', 'Wed-06', 'Wed-09', 'Wed-12', 'Wed-03', 'Wed-06', 'Wed-09', 'Thu-12']
+                labels: ['', 'Wed-12', 'Wed-03', 'Wed-06', 'Wed-09', 'Wed-12', 'Wed-03', 'Wed-06', 'Wed-09', 'Thu-12']
             },
             {
                 formatter: '%p',
                 positions: ['2019-12-31 18:00', '2020-01-01 06:00', '2020-01-01 18:00', '2020-01-02 06:00'],
-                labels: [' ', 'Wed-AM', 'Wed-PM', ' ']
+                labels: ['', 'Wed-AM', 'Wed-PM', '']
             },
             {
                 formatter: '%M',
                 positions: ['2019-12-31 21:00', '2020-01-01', '2020-01-01 03:00', '2020-01-01 06:00', '2020-01-01 09:00', '2020-01-01 12:00', '2020-01-01 15:00', '2020-01-01 18:00', '2020-01-01 21:00', '2020-01-02'],
-                labels: [' ', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Thu-00']
+                labels: ['', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Thu-00']
             },
             {
                 formatter: '%S',
                 positions: ['2019-12-31 21:00', '2020-01-01', '2020-01-01 03:00', '2020-01-01 06:00', '2020-01-01 09:00', '2020-01-01 12:00', '2020-01-01 15:00', '2020-01-01 18:00', '2020-01-01 21:00', '2020-01-02'],
-                labels: [' ', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Thu-00']
+                labels: ['', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Wed-00', 'Thu-00']
             },
             {
                 formatter: '%L',
                 positions: ['2019-12-31 21:00', '2020-01-01', '2020-01-01 03:00', '2020-01-01 06:00', '2020-01-01 09:00', '2020-01-01 12:00', '2020-01-01 15:00', '2020-01-01 18:00', '2020-01-01 21:00', '2020-01-02'],
-                labels: [' ', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Thu-000']
+                labels: ['', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Wed-000', 'Thu-000']
             },
             {
                 formatter: '%f',
                 positions: ['2019-12-31 21:00', '2020-01-01', '2020-01-01 03:00', '2020-01-01 06:00', '2020-01-01 09:00', '2020-01-01 12:00', '2020-01-01 15:00', '2020-01-01 18:00', '2020-01-01 21:00', '2020-01-02'],
-                labels: [' ', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Thu-0']
+                labels: ['', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Wed-0', 'Thu-0']
             }
         ].forEach(function(t) {
             it('should respect time tickformat that includes ' + t.formatter, function(done) {
@@ -5995,17 +5995,17 @@ describe('Test axes', function() {
             {
                 range: ['2019-12-10', '2020-01-10'],
                 positions: ['2019-12-16 12:00', '2020-01-10'],
-                labels: ['2019-Dec', ' ']
+                labels: ['2019-Dec', '']
             },
             {
                 range: ['2019-12-20', '2020-01-20'],
                 positions: ['2019-12-20', '2020-01-16 12:00'],
-                labels: [' ', '2020-Jan']
+                labels: ['', '2020-Jan']
             },
             {
                 range: ['2020-01-20', '2019-12-20'],
                 positions: ['2020-01-20', '2020-01-16 12:00'],
-                labels: [' ', '2020-Jan']
+                labels: ['', '2020-Jan']
             }
         ].forEach(function(t) {
             it('should position labels with monthly tickformat when auto dtick is weekly | range:' + t.range, function(done) {
@@ -6041,72 +6041,72 @@ describe('Test axes', function() {
             {
                 range: ['2020-12-15', '2084-12-15'],
                 positions: ['2020-07-01 15:00', '2030-07-02 15:00', '2040-07-01 15:00', '2050-07-02 15:00', '2060-07-01 15:00', '2070-07-02 15:00', '2080-07-01 15:00'],
-                labels: [' ', '2030', '2040', '2050', '2060', '2070', '2080']
+                labels: ['', '2030', '2040', '2050', '2060', '2070', '2080']
             },
             {
                 range: ['2020-12-15', '2052-12-15'],
                 positions: ['2020-07-01 15:00', '2025-07-02 15:00', '2030-07-02 15:00', '2035-07-02 15:00', '2040-07-01 15:00', '2045-07-02 15:00', '2050-07-02 15:00'],
-                labels: [' ', '2025', '2030', '2035', '2040', '2045', '2050']
+                labels: ['', '2025', '2030', '2035', '2040', '2045', '2050']
             },
             {
                 range: ['2020-12-15', '2036-12-15'],
                 positions: ['2020-07-01 15:00', '2022-07-02 15:00', '2024-07-01 15:00', '2026-07-02 15:00', '2028-07-01 15:00', '2030-07-02 15:00', '2032-07-01 15:00', '2034-07-02 15:00', '2036-07-01 15:00'],
-                labels: [' ', '2022', '2024', '2026', '2028', '2030', '2032', '2034', '2036']
+                labels: ['', '2022', '2024', '2026', '2028', '2030', '2032', '2034', '2036']
             },
             {
                 range: ['2020-12-15', '2028-12-15'],
                 positions: ['2020-07-02', '2021-07-02 12:00', '2022-07-02 12:00', '2023-07-02 12:00', '2024-07-02', '2025-07-02 12:00', '2026-07-02 12:00', '2027-07-02 12:00', '2028-07-01 12:00'],
-                labels: [' ', '2021', '2022', '2023', '2024', '2025', '2026', '2027', '2028']
+                labels: ['', '2021', '2022', '2023', '2024', '2025', '2026', '2027', '2028']
             },
             {
                 range: ['2020-12-15', '2024-12-15'],
                 positions: ['2020-07-16 05:15', '2021-01-16 05:15', '2021-07-16 05:15', '2022-01-16 05:15', '2022-07-16 05:15', '2023-01-16 05:15', '2023-07-16 05:15', '2024-01-16 05:15', '2024-07-16 05:15'],
-                labels: [' ', 'Jan 2021', 'Jul 2021', 'Jan 2022', 'Jul 2022', 'Jan 2023', 'Jul 2023', 'Jan 2024', 'Jul 2024']
+                labels: ['', 'Jan 2021', 'Jul 2021', 'Jan 2022', 'Jul 2022', 'Jan 2023', 'Jul 2023', 'Jan 2024', 'Jul 2024']
             },
             {
                 range: ['2020-12-15', '2022-12-15'],
                 positions: ['2020-10-16 05:15', '2021-01-16 05:15', '2021-04-16 05:15', '2021-07-16 05:15', '2021-10-16 05:15', '2022-01-16 05:15', '2022-04-16 05:15', '2022-07-16 05:15', '2022-10-16 05:15'],
-                labels: [' ', 'Jan 2021', 'Apr 2021', 'Jul 2021', 'Oct 2021', 'Jan 2022', 'Apr 2022', 'Jul 2022', 'Oct 2022']
+                labels: ['', 'Jan 2021', 'Apr 2021', 'Jul 2021', 'Oct 2021', 'Jan 2022', 'Apr 2022', 'Jul 2022', 'Oct 2022']
             },
             {
                 range: ['2020-12-15', '2021-12-15'],
                 positions: ['2020-11-16 05:15', '2021-01-16 05:15', '2021-03-16 05:15', '2021-05-16 05:15', '2021-07-16 05:15', '2021-09-16 05:15', '2021-11-16 05:15'],
-                labels: [' ', 'Jan 2021', 'Mar 2021', 'May 2021', 'Jul 2021', 'Sep 2021', 'Nov 2021']
+                labels: ['', 'Jan 2021', 'Mar 2021', 'May 2021', 'Jul 2021', 'Sep 2021', 'Nov 2021']
             },
             {
                 range: ['2020-12-15', '2021-06-15'],
                 positions: ['2020-12-16 12:00', '2021-01-16 12:00', '2021-02-15', '2021-03-16 12:00', '2021-04-16', '2021-05-16 12:00', '2021-06-16 12:00'],
-                labels: ['Dec 2020', 'Jan 2021', 'Feb 2021', 'Mar 2021', 'Apr 2021', 'May 2021', ' ']
+                labels: ['Dec 2020', 'Jan 2021', 'Feb 2021', 'Mar 2021', 'Apr 2021', 'May 2021', '']
             },
             {
                 range: ['2020-12-15', '2021-02-15'],
                 positions: ['2020-12-13 12:00', '2020-12-20 12:00', '2020-12-27 12:00', '2021-01-03 12:00', '2021-01-10 12:00', '2021-01-17 12:00', '2021-01-24 12:00', '2021-01-31 12:00', '2021-02-07 12:00', '2021-02-14 12:00'],
-                labels: [' ', 'Dec 20<br>2020', 'Dec 27', 'Jan 3<br>2021', 'Jan 10', 'Jan 17', 'Jan 24', 'Jan 31', 'Feb 7', 'Feb 14']
+                labels: ['', 'Dec 20<br>2020', 'Dec 27', 'Jan 3<br>2021', 'Jan 10', 'Jan 17', 'Jan 24', 'Jan 31', 'Feb 7', 'Feb 14']
             },
             {
                 range: ['2020-12-15', '2021-01-15'],
                 positions: ['2020-12-13 12:00', '2020-12-20 12:00', '2020-12-27 12:00', '2021-01-03 12:00', '2021-01-10 12:00'],
-                labels: [' ', 'Dec 20<br>2020', 'Dec 27', 'Jan 3<br>2021', 'Jan 10']
+                labels: ['', 'Dec 20<br>2020', 'Dec 27', 'Jan 3<br>2021', 'Jan 10']
             },
             {
                 range: ['2020-12-15', '2021-01-01'],
                 positions: ['2020-12-14 12:00', '2020-12-16 12:00', '2020-12-18 12:00', '2020-12-20 12:00', '2020-12-22 12:00', '2020-12-24 12:00', '2020-12-26 12:00', '2020-12-28 12:00', '2020-12-30 12:00', '2021-01-01 12:00'],
-                labels: [' ', 'Dec 16<br>2020', 'Dec 18', 'Dec 20', 'Dec 22', 'Dec 24', 'Dec 26', 'Dec 28', 'Dec 30', ' ']
+                labels: ['', 'Dec 16<br>2020', 'Dec 18', 'Dec 20', 'Dec 22', 'Dec 24', 'Dec 26', 'Dec 28', 'Dec 30', '']
             },
             {
                 range: ['2020-12-15', '2020-12-21'],
                 positions: ['2020-12-14 12:00', '2020-12-15 12:00', '2020-12-16 12:00', '2020-12-17 12:00', '2020-12-18 12:00', '2020-12-19 12:00', '2020-12-20 12:00', '2020-12-21 12:00'],
-                labels: [' ', 'Dec 15<br>2020', 'Dec 16', 'Dec 17', 'Dec 18', 'Dec 19', 'Dec 20', ' ']
+                labels: ['', 'Dec 15<br>2020', 'Dec 16', 'Dec 17', 'Dec 18', 'Dec 19', 'Dec 20', '']
             },
             {
                 range: ['2020-12-15', '2020-12-16'],
                 positions: ['2020-12-14 21:00', '2020-12-15', '2020-12-15 03:00', '2020-12-15 06:00', '2020-12-15 09:00', '2020-12-15 12:00', '2020-12-15 15:00', '2020-12-15 18:00', '2020-12-15 21:00', '2020-12-16'],
-                labels: [' ', '00:00<br>Dec 15, 2020', '03:00', '06:00', '09:00', '12:00', '15:00', '18:00', '21:00', '00:00<br>Dec 16, 2020']
+                labels: ['', '00:00<br>Dec 15, 2020', '03:00', '06:00', '09:00', '12:00', '15:00', '18:00', '21:00', '00:00<br>Dec 16, 2020']
             },
             {
                 range: ['2020-12-15', '2020-12-15 12:00'],
                 positions: ['2020-12-14 22:00', '2020-12-15', '2020-12-15 02:00', '2020-12-15 04:00', '2020-12-15 06:00', '2020-12-15 08:00', '2020-12-15 10:00', '2020-12-15 12:00'],
-                labels: [' ', '00:00<br>Dec 15, 2020', '02:00', '04:00', '06:00', '08:00', '10:00', '12:00']
+                labels: ['', '00:00<br>Dec 15, 2020', '02:00', '04:00', '06:00', '08:00', '10:00', '12:00']
             }
         ].forEach(function(t) {
             it('should position auto labels | range:' + t.range, function(done) {
@@ -6161,72 +6161,72 @@ describe('Test axes', function() {
             {
                 range: ['2084-12-15', '2020-12-15'],
                 positions: ['2090-07-02 15:00', '2080-07-01 15:00', '2070-07-02 15:00', '2060-07-01 15:00', '2050-07-02 15:00', '2040-07-01 15:00', '2030-07-02 15:00'],
-                labels: [' ', '2080', '2070', '2060', '2050', '2040', '2030']
+                labels: ['', '2080', '2070', '2060', '2050', '2040', '2030']
             },
             {
                 range: ['2052-12-15', '2020-12-15'],
                 positions: ['2055-07-02 15:00', '2050-07-02 15:00', '2045-07-02 15:00', '2040-07-01 15:00', '2035-07-02 15:00', '2030-07-02 15:00', '2025-07-02 15:00'],
-                labels: [' ', '2050', '2045', '2040', '2035', '2030', '2025']
+                labels: ['', '2050', '2045', '2040', '2035', '2030', '2025']
             },
             {
                 range: ['2036-12-15', '2020-12-15'],
                 positions: ['2038-07-02 15:00', '2036-07-01 15:00', '2034-07-02 15:00', '2032-07-01 15:00', '2030-07-02 15:00', '2028-07-01 15:00', '2026-07-02 15:00', '2024-07-01 15:00', '2022-07-02 15:00'],
-                labels: [' ', '2036', '2034', '2032', '2030', '2028', '2026', '2024', '2022']
+                labels: ['', '2036', '2034', '2032', '2030', '2028', '2026', '2024', '2022']
             },
             {
                 range: ['2028-12-15', '2020-12-15'],
                 positions: ['2029-07-03', '2028-07-01 12:00', '2027-07-02 12:00', '2026-07-02 12:00', '2025-07-03', '2024-07-01 12:00', '2023-07-02 12:00', '2022-07-02 12:00', '2021-07-02 12:00'],
-                labels: [' ', '2028', '2027', '2026', '2025', '2024', '2023', '2022', '2021']
+                labels: ['', '2028', '2027', '2026', '2025', '2024', '2023', '2022', '2021']
             },
             {
                 range: ['2024-12-15', '2020-12-15'],
                 positions: ['2025-01-16 05:15', '2024-07-16 05:15', '2024-01-16 05:15', '2023-07-16 05:15', '2023-01-16 05:15', '2022-07-16 05:15', '2022-01-16 05:15', '2021-07-16 05:15', '2021-01-16 05:15'],
-                labels: [' ', 'Jul 2024', 'Jan 2024', 'Jul 2023', 'Jan 2023', 'Jul 2022', 'Jan 2022', 'Jul 2021', 'Jan 2021']
+                labels: ['', 'Jul 2024', 'Jan 2024', 'Jul 2023', 'Jan 2023', 'Jul 2022', 'Jan 2022', 'Jul 2021', 'Jan 2021']
             },
             {
                 range: ['2022-12-15', '2020-12-15'],
                 positions: ['2023-01-16 05:15', '2022-10-16 05:15', '2022-07-16 05:15', '2022-04-16 05:15', '2022-01-16 05:15', '2021-10-16 05:15', '2021-07-16 05:15', '2021-04-16 05:15', '2021-01-16 05:15'],
-                labels: [' ', 'Oct 2022', 'Jul 2022', 'Apr 2022', 'Jan 2022', 'Oct 2021', 'Jul 2021', 'Apr 2021', 'Jan 2021']
+                labels: ['', 'Oct 2022', 'Jul 2022', 'Apr 2022', 'Jan 2022', 'Oct 2021', 'Jul 2021', 'Apr 2021', 'Jan 2021']
             },
             {
                 range: ['2021-12-15', '2020-12-15'],
                 positions: ['2022-01-16 05:15', '2021-11-16 05:15', '2021-09-16 05:15', '2021-07-16 05:15', '2021-05-16 05:15', '2021-03-16 05:15', '2021-01-16 05:15'],
-                labels: [' ', 'Nov 2021', 'Sep 2021', 'Jul 2021', 'May 2021', 'Mar 2021', 'Jan 2021']
+                labels: ['', 'Nov 2021', 'Sep 2021', 'Jul 2021', 'May 2021', 'Mar 2021', 'Jan 2021']
             },
             {
                 range: ['2021-06-15', '2020-12-15'],
                 positions: ['2021-07-16', '2021-06-16 12:00', '2021-05-16', '2021-04-16 12:00', '2021-03-15', '2021-02-16 12:00', '2021-01-16 12:00'],
-                labels: [' ', ' ', 'May 2021', 'Apr 2021', 'Mar 2021', 'Feb 2021', 'Jan 2021']
+                labels: ['', '', 'May 2021', 'Apr 2021', 'Mar 2021', 'Feb 2021', 'Jan 2021']
             },
             {
                 range: ['2021-02-15', '2020-12-15'],
                 positions: ['2021-02-21 12:00', '2021-02-14 12:00', '2021-02-07 12:00', '2021-01-31 12:00', '2021-01-24 12:00', '2021-01-17 12:00', '2021-01-10 12:00', '2021-01-03 12:00', '2020-12-27 12:00', '2020-12-20 12:00'],
-                labels: [' ', 'Feb 14<br>2021', 'Feb 7', 'Jan 31', 'Jan 24', 'Jan 17', 'Jan 10', 'Jan 3', 'Dec 27<br>2020', 'Dec 20']
+                labels: ['', 'Feb 14<br>2021', 'Feb 7', 'Jan 31', 'Jan 24', 'Jan 17', 'Jan 10', 'Jan 3', 'Dec 27<br>2020', 'Dec 20']
             },
             {
                 range: ['2021-01-15', '2020-12-15'],
                 positions: ['2021-01-17 12:00', '2021-01-10 12:00', '2021-01-03 12:00', '2020-12-27 12:00', '2020-12-20 12:00'],
-                labels: [' ', 'Jan 10<br>2021', 'Jan 3', 'Dec 27<br>2020', 'Dec 20']
+                labels: ['', 'Jan 10<br>2021', 'Jan 3', 'Dec 27<br>2020', 'Dec 20']
             },
             {
                 range: ['2021-01-01', '2020-12-15'],
                 positions: ['2021-01-03 12:00', '2021-01-01 12:00', '2020-12-30 12:00', '2020-12-28 12:00', '2020-12-26 12:00', '2020-12-24 12:00', '2020-12-22 12:00', '2020-12-20 12:00', '2020-12-18 12:00', '2020-12-16 12:00'],
-                labels: [' ', ' ', 'Dec 30<br>2020', 'Dec 28', 'Dec 26', 'Dec 24', 'Dec 22', 'Dec 20', 'Dec 18', 'Dec 16']
+                labels: ['', '', 'Dec 30<br>2020', 'Dec 28', 'Dec 26', 'Dec 24', 'Dec 22', 'Dec 20', 'Dec 18', 'Dec 16']
             },
             {
                 range: ['2020-12-21', '2020-12-15'],
                 positions: ['2020-12-22 12:00', '2020-12-21 12:00', '2020-12-20 12:00', '2020-12-19 12:00', '2020-12-18 12:00', '2020-12-17 12:00', '2020-12-16 12:00', '2020-12-15 12:00'],
-                labels: [' ', ' ', 'Dec 20<br>2020', 'Dec 19', 'Dec 18', 'Dec 17', 'Dec 16', 'Dec 15']
+                labels: ['', '', 'Dec 20<br>2020', 'Dec 19', 'Dec 18', 'Dec 17', 'Dec 16', 'Dec 15']
             },
             {
                 range: ['2020-12-16', '2020-12-15'],
                 positions: ['2020-12-16 03:00', '2020-12-16', '2020-12-15 21:00', '2020-12-15 18:00', '2020-12-15 15:00', '2020-12-15 12:00', '2020-12-15 09:00', '2020-12-15 06:00', '2020-12-15 03:00', '2020-12-15'],
-                labels: [' ', '00:00<br>Dec 16, 2020', '21:00<br>Dec 15, 2020', '18:00', '15:00', '12:00', '09:00', '06:00', '03:00', '00:00']
+                labels: ['', '00:00<br>Dec 16, 2020', '21:00<br>Dec 15, 2020', '18:00', '15:00', '12:00', '09:00', '06:00', '03:00', '00:00']
             },
             {
                 range: ['2020-12-15 12:00', '2020-12-15'],
                 positions: ['2020-12-15 14:00', '2020-12-15 12:00', '2020-12-15 10:00', '2020-12-15 08:00', '2020-12-15 06:00', '2020-12-15 04:00', '2020-12-15 02:00', '2020-12-15'],
-                labels: [' ', '12:00<br>Dec 15, 2020', '10:00', '08:00', '06:00', '04:00', '02:00', '00:00']
+                labels: ['', '12:00<br>Dec 15, 2020', '10:00', '08:00', '06:00', '04:00', '02:00', '00:00']
             }
         ].forEach(function(t) {
             it('should position auto labels | reversed range:' + t.range, function(done) {
@@ -6286,7 +6286,7 @@ describe('Test axes', function() {
             {
                 range: ['2020-12-14 08:00', '2021-08-14 08:00'],
                 positions: ['2021-01-16 18:00', '2021-02-15 06:00', '2021-03-16 18:00', '2021-04-16 06:00', '2021-05-16 18:00', '2021-06-16 06:00', '2021-07-16 18:00', '2021-08-16 18:00'],
-                labels: ['Jan 2021', 'Feb 2021', 'Mar 2021', 'Apr 2021', 'May 2021', 'Jun 2021', 'Jul 2021', ' ']
+                labels: ['Jan 2021', 'Feb 2021', 'Mar 2021', 'Apr 2021', 'May 2021', 'Jun 2021', 'Jul 2021', '']
             },
             {
                 range: ['2020-12-14 08:00', '2021-04-14 08:00'],
@@ -6306,12 +6306,12 @@ describe('Test axes', function() {
             {
                 range: ['2020-12-14 08:00', '2021-01-01 08:00'],
                 positions: ['2020-12-16 12:00', '2020-12-18 12:00', '2020-12-22 12:00', '2020-12-24 12:00', '2020-12-28 12:00', '2020-12-30 12:00', '2021-01-01 12:00'],
-                labels: ['Dec 16<br>2020', 'Dec 18', 'Dec 22', 'Dec 24', 'Dec 28', 'Dec 30', ' ']
+                labels: ['Dec 16<br>2020', 'Dec 18', 'Dec 22', 'Dec 24', 'Dec 28', 'Dec 30', '']
             },
             {
                 range: ['2020-12-14 08:00', '2020-12-22 08:00'],
                 positions: ['2020-12-15 12:00', '2020-12-16 12:00', '2020-12-17 12:00', '2020-12-18 12:00', '2020-12-21 12:00', '2020-12-22 12:00'],
-                labels: ['Dec 15<br>2020', 'Dec 16', 'Dec 17', 'Dec 18', 'Dec 21', ' ']
+                labels: ['Dec 15<br>2020', 'Dec 16', 'Dec 17', 'Dec 18', 'Dec 21', '']
             },
             {
                 range: ['2020-12-14 08:00', '2020-12-18 08:00'],
